/*-----------------------------------------------------------------------------

 2002, Jeff M Soft und Hardware GmbH, All Rights Reserved

-----------------------------------------------------------------------------*/

#include "Module.h"
#include "E:\SDK2_SE_R\SEMod_struct.h"
#include "E:\SDK2_SE_R\SEPin.h"

#include <assert.h>

#include <stdio.h> // files
#include <io.h>

#include <stdlib.h>
#include <string.h>
#include <process.h>
#include <wchar.h>




void Module::sub_process(long buffer_offset, long sampleFrames )
{ 
	
	float *in       = buffer_offset + input1_buffer; 
	
    for(i = 1; i <= 12 ;i++)
	{
	 O[i]  = buffer_offset + o[i];
	}

	while(--sampleFrames >= 0) // sampleFrames = how many samples to process (can vary). repeat (loop) that many times
    {
   
    for(i = 1; i <= 12 ;i++)
	{
      if (B[i] == true) *O[i] = *in; else *O[i] = 0.0f;
	}
	
	in++;
    for(i = 1; i <= 12 ;i++)
	{
	 O[i]++;
	}

	}
}

// The core of a MIDI plugin
void Module::OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id)
{
 
	// system messages are for timing info etc
	// they don't have a channel, just pass them right through
	bool is_system_msg = ( midi_msg & SYSTEM_MSG ) == SYSTEM_MSG;

	if( !is_system_msg )
	{
		  //int 
		
		stat = midi_msg & 0xf0;//on off
		note = ( midi_msg / 0x100 ) & 0xff; // note


if(stat == NOTE_ON)
	{
		for(k = erst; k <= letzt ; k+= 12)
		{
		 for(i = 1; i <= 12 ;i++)
	     {
		  if(note == (k + i))	
		  {
			 
			  B[i]=true;
            
			 break;
		  }
	     }
		}
	}
    
	if(stat == NOTE_OFF)
	{
		for(k = erst; k <= letzt ; k+= 12)
		{
		 for(i = 1; i <= 12 ;i++)
	     {
		  if(note == (k + i))	
		  {
          
			  B[i]=false;
           
			 break;
		  }
	     }
		}
	}


















		getPin(PN_MIDI_OUT)->TransmitMIDI(SampleClock(), midi_msg);
	}
}
/*
		// The first byte of a midi message contains the status (note on/off etc) and the channel
		int chan = midi_msg & 0x0f;//channel
		
		// the next two bytes depend on the type of message
		
		int b3 = ( midi_msg / 0x10000 ) & 0xff; // velo
        */
Module::Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1) : SEModule_base(seaudioMaster, p_resvd1)
{
}

void Module::open()
{   
	err = -1;
	err2 = -1;
    isnew = false;
	SEModule_base::open();
	// choose which function is used to process audio
	SET_PROCESS_FUNC(Module::sub_process);
}

Module::~Module()
{
	_fcloseall();
}

// describe the module
bool Module::getModuleProperties (SEModuleProperties* properties)
{  
   LL dish;
   BB bish;
   sprintf_s(dish.thisSEM   ,100, "%s\n","MIDI_THRU_LED_M" );
   int j;

   j  = sprintf_s(  bish.buffer    ,1000, "%s\n", " ************************************" );
   j  = sprintf_s(  bish.buffer + j,1000, "%s\n", " * 2009 December in Tbingen GERMANY " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *            FAKE MUSIC             " ); 
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *         by ralph.a.cronin         " ); 
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,1000, "%s"  ,   dish.thisSEM );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *          enjoy SYNTHEDIT          " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *        by Jeff Mc Clintock        " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );

	properties->name = dish.thisSEM;	// this is the name the end-user will see
	properties->id = dish.thisSEM;
	properties->about =  bish.buffer;//"by ralph a. cronin and Jeff M";
	return true;
}

// describe the pins (plugs)
bool Module::getPinProperties (long index, SEPinProperties* properties)
{
	switch( index )
	{
	case 0:
		properties->name				= "MIDI In";
		properties->direction			= DR_IN;
		properties->datatype			= DT_MIDI2;
		break;
	 case 1:	
		
		properties->name				= "in";
		properties->variable_address	= &input1_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value       = "20.0f";
		break;
	
	 case 2: 
	    properties->name				= "C";
		properties->variable_address	= &o[index-1];
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	  case 3: 
		properties->name				= "C#";
		properties->variable_address	= &o[index-1];
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	 case 4: 
        properties->name				= "D";
		properties->variable_address	= &o[index-1];
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	 case 5:
		properties->name				= "D#";
		properties->variable_address	= &o[index-1];
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	 case 6:
        properties->name				= "E";
		properties->variable_address	= &o[index-1];
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	 case 7:
		 properties->name				= "F";
		properties->variable_address	= &o[index-1];
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	 case 8:
		 properties->name				= "F#";
		properties->variable_address	= &o[index-1];
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	 case 9:
        properties->name				= "G";
		properties->variable_address	= &o[index-1];
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	 case 10:
	    properties->name				= "G#";
		properties->variable_address	= &o[index-1];
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	 case 11:
        properties->name				= "A";
		properties->variable_address	= &o[index-1];
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	 case 12:
	    properties->name				= "A#";
		properties->variable_address	= &o[index-1];
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	 case 13:
        properties->name				= "H";
		properties->variable_address	= &o[index-1];
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
    case 14:
		properties->name				= "MIDI Out";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;

	default:
		return false; // host will ask for plugs 0,1,2,3 etc. return false to signal when done
	};

	return true;
}

void Module::diag(char * melde)
{
 err2= fopen_s(&textfile,"D:\\DIAGNOSE.TXT","a+");
 if(err2 == 0)
 {
	 fwrite(melde, sizeof(char),strlen(melde), textfile);
     fclose(textfile);
 }
}

void Module::OnPlugStateChange(SEPin *pin)
{ 
// state_type ist =getPin(PN_MIDI_IN)->getStatus();	
// if(ist = ST_RUN)
 {
 getPin(PN_1)->TransmitStatusChange( SampleClock(), ST_RUN);
 getPin(PN_2)->TransmitStatusChange( SampleClock(), ST_RUN);
 getPin(PN_3)->TransmitStatusChange( SampleClock(), ST_RUN);
 getPin(PN_4)->TransmitStatusChange( SampleClock(), ST_RUN);

 getPin(PN_5)->TransmitStatusChange( SampleClock(), ST_RUN);
 getPin(PN_6)->TransmitStatusChange( SampleClock(), ST_RUN);
 getPin(PN_7)->TransmitStatusChange( SampleClock(), ST_RUN);
 getPin(PN_8)->TransmitStatusChange( SampleClock(), ST_RUN);

 getPin(PN_9)->TransmitStatusChange( SampleClock(), ST_RUN);
 getPin(PN_10)->TransmitStatusChange( SampleClock(), ST_RUN);
 getPin(PN_11)->TransmitStatusChange( SampleClock(), ST_RUN);
 getPin(PN_12)->TransmitStatusChange( SampleClock(), ST_RUN);
 }/*
 else
 {
  for(i=2;i<=13;i++) getPin(i)->TransmitStatusChange( SampleClock(), ST_STATIC);
 }
*/


}