/*-----------------------------------------------------------------------------

 2002, Jeff M Soft und Hardware GmbH, All Rights Reserved

-----------------------------------------------------------------------------*/

#include "Module.h"
#include "E:\SDK2_SE_R\SEMod_struct.h"
#include "E:\SDK2_SE_R\SEPin.h"
#include <assert.h>

#include <stdio.h> // files
#include <io.h> // filelenght ..

#include <string.h>


void Module::sub_process(long buffer_offset, long sampleFrames )
{  
	buffnow = buffer_offset;

/*
    float *gate1  = buffer_offset + gate1_buff;
    float *gate2  = buffer_offset + gate2_buff;
    float *gate3  = buffer_offset + gate3_buff;
    float *pitch1 = buffer_offset + pitch1_buff;
	float *pitch2 = buffer_offset + pitch2_buff;
    float *pitch3 = buffer_offset + pitch3_buff;
    float *velo1  = buffer_offset + velo1_buff;
    float *velo2  = buffer_offset + velo2_buff;
    float *velo3  = buffer_offset + velo3_buff;

	while(--sampleFrames >= 0)
	{
    	               
        
	
	gate1++;
	gate2++;
	gate3++;
	pitch1++;
	pitch2++;
	pitch3++;
	velo1++;
	velo2++;
	velo3++;
	}
	*/
	sampleFrames = 0;
}

// The core of a MIDI plugin
void Module::OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id)
{

	/*
	*(buffnow + gate1_buff) = -1.0f;

	*(buffnow + gate2_buff) = -1.0f;

	*(buffnow + gate3_buff) = -1.0f;

*/


	bool is_system_msg = ( midi_msg & SYSTEM_MSG ) == SYSTEM_MSG;

	if( !is_system_msg )
	{
		// The first byte of a midi message contains the status (note on/off etc) and the channel
		int chan = midi_msg & 0x0f;
		int b2 , b3;
		float pitch , velo;
		if(chan == 0)
		{
		  int stat = midi_msg & 0xf0; // the next two bytes depend on the type of message
		  switch( stat )
		  {
		   case NOTE_ON:
			   {
			    b2 = ( midi_msg / 0x100 ) & 0xff;   // NOTE
                if((from <= b2)&&( b2 <= to))           // NOTE ist IM BEREICH
		        {
                 pitch = (5 + ( b2 - 69 )  / 12) / 10.0f;
		         b3 = ( midi_msg / 0x10000 ) & 0xff; // VELO
				 velo = b3 / 10.0f;
// VELO SPLIT :
			     if ( b3 <  50 )               // velo1
			     {
                  *(buffnow + pitch1_buff) = pitch;
				  *(buffnow + gate1_buff)  =  1.0f;
				  *(buffnow + velo1_buff)  =  velo;
				 
			     }
			     if(( 50 <= b3 )&&( b3 < 90 )) // velo2
			     {
                  *(buffnow + pitch2_buff) = pitch;
                  *(buffnow + gate2_buff)  =  1.0f;
                  *(buffnow + velo2_buff)  =  velo;
			     }
			     if ( 90 <= b3 )               // velo3
		     	 {
                  *(buffnow + pitch3_buff) = pitch;
                  *(buffnow + gate3_buff)  =  1.0f;
                  *(buffnow + velo3_buff)  =  velo;
			     }
				}//if from
				break;
			   }//note on
		 case NOTE_OFF:
			   {
			    b2 = ( midi_msg / 0x100 ) & 0xff;   // NOTE
                if((from <= b2)&&( b2 <= to))           // NOTE ist IM BEREICH
		        {
                 pitch = (5 + ( b2 - 69 )  / 12) / 10.0f;
		         b3 = ( midi_msg / 0x10000 ) & 0xff; // VELO
// VELO SPLIT :
			     if ( b3 <  50 )               // velo1
			     {
                  *(buffnow + pitch1_buff) = pitch;
		          *(buffnow + gate1_buff)  = 0.0f;
			     }
			     if(( 50 <= b3 )&&( b3 < 90 )) // velo2
			     {
                  *(buffnow + pitch2_buff) = pitch;
                  *(buffnow + gate2_buff)  = 0.0f;
			     }
			     if ( 90 <= b3 )               // velo3
		     	 {
                  *(buffnow + pitch3_buff) = pitch;
                  *(buffnow + gate3_buff)  = 0.0f;
			     }
		  
				}//if from
				break;
			   }//note off
		  }//switch stat


		}//chan
	}//system
	
}//midi

Module::Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1) : SEModule_base(seaudioMaster, p_resvd1)
{
}

void Module::open()
{ 
	err2 = -1;
	SEModule_base::open();
  
	// choose which function is used to process audio
	SET_PROCESS_FUNC(Module::sub_process);
}

Module::~Module()
{
	
	
}

// describe the module
bool Module::getModuleProperties (SEModuleProperties* properties)
{
   LL dish;
   BB bish;
   sprintf_s(dish.thisSEM   ,100, "%s\n", "MIDI_to_SPLIT1_M");
   int j;

   j  = sprintf_s(  bish.buffer    ,1000, "%s\n", " ************************************" );
   j  = sprintf_s(  bish.buffer + j,1000, "%s\n", " * 2009 December in Tbingen GERMANY " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *            FAKE MUSIC             " ); 
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *         by ralph.a.cronin         " ); 
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,1000, "%s"  ,   dish.thisSEM );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *          enjoy SYNTHEDIT          " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *        by Jeff Mc Clintock        " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );

   // MAXIS :
   // j += sprintf( buffer + j, "%s\n", " **************************************************************************************" );//120
   // j += sprintf( buffer + j, "%s\n", "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" ); // = 54


	properties->name = dish.thisSEM;	// this is the name the end-user will see

	// return a uni+																																																			que string.
	// if posible include manufacturer and plugin identity
	// this is used internally by SE to identify the plug. No two plugs may have the same id.
	properties->id = dish.thisSEM;

	// Info, may include Author, Web page whatever
	properties->about =  bish.buffer;//"by ralph a. cronin and Jeff M";
	return true;
   
}

// describe the pins (plugs)
bool Module::getPinProperties (long index, SEPinProperties* properties)
{
	switch( index )
	{
	case 0:
		properties->name				= "MIDI IN";
		properties->direction			= DR_IN;
		properties->datatype			= DT_MIDI2;
		break;
    case 1:
		properties->name				= "(note";
        properties->variable_address	= &from;
		properties->datatype_extra		= "range 0,127";
		properties->default_value		= "80";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 2:	
		properties->name                = "note)";
        properties->variable_address	= &to;
		properties->datatype_extra		= "range 0,127";
		properties->default_value		= "80";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
        break;
	case 3:
		properties->name				= "G1";
        properties->variable_address	= &gate1_buff;
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	case 4:
		properties->name				= "P1";
        properties->variable_address	= &pitch1_buff;
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
    case 5:
		properties->name				= "V1";
        properties->variable_address	= &velo1_buff;
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
    case 6:
		properties->name				= "G2";
        properties->variable_address	= &gate2_buff;
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	case 7:
		properties->name				= "P2";
        properties->variable_address	= &pitch2_buff;
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
    case 8:
		properties->name				= "V2";
        properties->variable_address	= &velo2_buff;
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
    case 9:
		properties->name				= "G3";
        properties->variable_address	= &gate3_buff;
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	case 10:
		properties->name				= "P3";
        properties->variable_address	= &pitch3_buff;
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
    case 11:
		properties->name				= "V3";
        properties->variable_address	= &velo3_buff;
		properties->direction			= DR_OUT;
		properties->datatype			= DT_FSAMPLE;
		break;
	case 12:
		properties->name				= "on D: DIAGNOSE.TXT";
		properties->variable_address	= &admin;
		properties->direction			= DR_PARAMETER;
        properties->datatype			= DT_BOOL;
		properties->default_value		= "false";
		break;
	
	default:
		return false; // host will ask for plugs 0,1,2,3 etc. return false to signal when done
	};

	return true;
}

void Module::diag(char * melde)
{
 if(admin)
 {
  err2= fopen_s(&textfile,"D:\\DIAGNOSE.TXT","a+");
  if(err2 == 0)
  {
	 fwrite(melde, sizeof(char),strlen(melde), textfile);
     fclose(textfile);
  }
 }
}

void Module::OnPlugStateChange(SEPin *pin)
{
 for (int i = 3; i <= 11 ; i++ )
 { 
	 getPin(i)->TransmitStatusChange( SampleClock(), ST_RUN);// statt out_stat ralph
 }
}


