/*-----------------------------------------------------------------------------

 2002, Jeff M Soft und Hardware GmbH, All Rights Reserved

-----------------------------------------------------------------------------*/

#include "Module.h"
#include "SEMod_struct.h"
#include "SEPin.h"
#include <assert.h>

//#include <fcntl.h>     /* for _O_TEXT and _O_BINARY */
//#include <errno.h>     /* for EINVAL */
//#include <sys\stat.h>  /* for _S_IWRITE */

#include <stdio.h> // files
#include <io.h> // filelenght ..
#include <string.h>
//#include <process.h>
//#include <wchar.h>

#define SYSTEM_MSG		        0xF0
#define NOTE_OFF                0x80
#define NOTE_ON                 0x90

#define MAX_FILENAME_LENGTH 400

void Module::sub_process(long buffer_offset, long sampleFrames )
{  
	//float *in1    = buffer_offset + input1_buffer;
    float *in1    = buffer_offset + input1_buffer;
    float *in2    = buffer_offset + input2_buffer;
	float *kick   = buffer_offset + input3_buffer;
    
		               
        if ((*in1 > 0.2)&&(last_take > 0)) PLAY = true; else PLAY = false;
		if ( *in2 > 0.2) // STOP
		{
			taki = 0;
            got_one = false;
			PLAY    = false;
		}
		if(PLAY)
		{  
		  if((got_one == false)&&(taki <= last_take))
	      {
	       midi  = tak_midi[taki];
	       got_one = true;
	      }

	      if(got_one == true)
	      {
           if((wasoff == true)&&(*kick > 0.2f))
	       {
		    getPin(PN_MIDI_OUT)->TransmitMIDI(SampleClock(), midi);
		    taki++; if(loop == 1){if (taki > last_take) taki = 0; }
			got_one = false;
			wasoff  = false;
	       }
		  }
		  if(*kick < 0.2f) wasoff = true;
		}
        sampleFrames = 0;
}

// The core of a MIDI plugin
void Module::OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id)
{
	
}

Module::Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1) : SEModule_base(seaudioMaster, p_resvd1)
{
}

void Module::open()
{ 
err = -1;
err0 = -1;
err2 = -1;

smidi_rec_file  = NULL;
smidi_play_file  = NULL;
textfile = NULL;
stream = NULL;

isnew = false;
isnew0 = false;
didonce = false;
got_one = false;

done = 0;	

	canload = false;

	done = 0;got_one = false;

	SEModule_base::open();
  
	// choose which function is used to process audio
	SET_PROCESS_FUNC(Module::sub_process);
}

Module::~Module()
{
	
	_fcloseall();
}

// describe the module
bool Module::getModuleProperties (SEModuleProperties* properties)
{
/*
   sprintf_s( thisSEM   ,100, "%s\n", "SMIDI_PLAY_KICK1_M" );
   int j;

   j  = sprintf_s( buffer    ,1000, "%s\n", " ************************************" );
   j  = sprintf_s( buffer + j,1000, "%s\n", " * 2009 December in Tbingen GERMANY " );
   j += sprintf_s( buffer + j,1000, "%s\n", " *            FAKE MUSIC             " ); 
   j += sprintf_s( buffer + j,1000, "%s\n", " *         by ralph.a.cronin         " ); 
   j += sprintf_s( buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s( buffer + j,1000, "%s"  ,   thisSEM );
   j += sprintf_s( buffer + j,1000, "%s\n", " *      PLAYER for SMIDI Files       " );
   j += sprintf_s( buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s( buffer + j,1000, "%s\n", " *          enjoy SYNTHEDIT          " );
   j += sprintf_s( buffer + j,1000, "%s\n", " *        by Jeff Mc Clintock        " );
   j += sprintf_s( buffer + j,1000, "%s\n", " ************************************" );

   // MAXIS :
   // j += sprintf( buffer + j, "%s\n", " **************************************************************************************" );//120
   // j += sprintf( buffer + j, "%s\n", "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" ); // = 54


	properties->name = thisSEM;	// this is the name the end-user will see

	// return a uni+																																																			que string.
	// if posible include manufacturer and plugin identity
	// this is used internally by SE to identify the plug. No two plugs may have the same id.
	properties->id = thisSEM;

	// Info, may include Author, Web page whatever
	properties->about = buffer;//"by ralph a. cronin and Jeff M";
	return true;
*/

LL dish;
   BB bish;
   sprintf_s(dish.thisSEM   ,100, "%s\n", "SMIDI_PLAY_KICK1_M" );
   int j;

   j  = sprintf_s(  bish.buffer    ,1000, "%s\n", " ************************************" );
   j  = sprintf_s(  bish.buffer + j,1000, "%s\n", " * 2009 December in Tbingen GERMANY " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *            FAKE MUSIC             " ); 
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *         by ralph.a.cronin         " ); 
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,1000, "%s"  ,   dish.thisSEM );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *      PLAYER for SMIDI Files       " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *          enjoy SYNTHEDIT          " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " *        by Jeff Mc Clintock        " );
   j += sprintf_s(  bish.buffer + j,1000, "%s\n", " ************************************" );

   // MAXIS :
   // j += sprintf( buffer + j, "%s\n", " **************************************************************************************" );//120
   // j += sprintf( buffer + j, "%s\n", "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" ); // = 54


	properties->name = dish.thisSEM;	// this is the name the end-user will see

	// return a uni+																																																			que string.
	// if posible include manufacturer and plugin identity
	// this is used internally by SE to identify the plug. No two plugs may have the same id.
	properties->id = dish.thisSEM;

	// Info, may include Author, Web page whatever
	properties->about =  bish.buffer;//"by ralph a. cronin and Jeff M";
	return true;






}

// describe the pins (plugs)
bool Module::getPinProperties (long index, SEPinProperties* properties)
{
	switch( index )
	{
	
	
	case 0:
		properties->name				= "PLAY";
		properties->variable_address	= &input1_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
        properties->datatype_extra      = "10,0,10,0";
		break;
    case 1:
		properties->name				= "STOP";
		properties->variable_address	= &input2_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
        properties->datatype_extra      = "10,0,10,0";
		break;
    case 2:
		properties->name				= "KICK";
		properties->variable_address	= &input3_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
        properties->datatype_extra      = "10,0,10,0";
		break;
	case 3:	
		properties->name                = "SMIDI_PLAYFILE";
        properties->variable_address    = &text_input;
        properties->direction           = DR_IN;
        properties->datatype            = DT_TEXT; 
        properties->flags               = IO_FILENAME;
        properties->datatype_extra      ="smidi"; // file extension
        break;
	case 4:
		properties->name				= "loopit";
		properties->variable_address	= &loop;
		properties->datatype_extra		= "range 0,1";
		properties->default_value		= "0";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 5:
		properties->name				= "MIDI Out";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
	case 6:
		properties->name				= "on D: DIAGNOSE.TXT";
		properties->variable_address	= &admin;
		properties->direction			= DR_PARAMETER;
        properties->datatype			= DT_BOOL;
		properties->default_value		= "false";
		break;
	
	default:
		return false; // host will ask for plugs 0,1,2,3 etc. return false to signal when done
	};

	return true;
}

void Module::diag(char * melde)
{
 err2= fopen_s(&textfile,"D:\\DIAGNOSE.TXT","a+");
 if(err2 == 0)
 {
	 fwrite(melde, sizeof(char),strlen(melde), textfile);
     fclose(textfile);
 }
}

void Module::OnPlugStateChange(SEPin *pin)
{
    in_stat = getPin(PN_TEXT)->getStatus(); // bei 1 wechsel
    if(in_stat == ((state_type)1))
	{
	CallHost(seaudioMasterResolveFilename,PN_TEXT, MAX_FILENAME_LENGTH, (void *) full_path );
    //sprintf_s(text,400,"stat= %d \n",in_stat);
    //if(err2 == 0) fwrite(text, sizeof(char),strlen(text), textfile);
    sprintf_s(text,400,"%s\n",full_path);diag(text);
	
    //sprintf_s(text,400,"text_input= %s \n", text_input);
	//if(err2 == 0) fwrite(text, sizeof(char),strlen(text), textfile);
    wcscpy_s((wchar_t *)&smidi_play_name,strlen(full_path),(wchar_t *)&full_path);// copy name
    canload = true;
	loadarray();
    // err0 =  fopen_s(&smidi_play_file, smidi_play_name,"rb");
	isnew0 = true;
	}// here we got new path if !


/*
    state_type out_stat = ST_STATIC;
	for (int i = 1; i <= 3; i++)
	{
	 in_stat = getPin(i)->getStatus();
	 if( in_stat > ST_STATIC ) 
	         {
				 out_stat = ST_RUN; 
				 break;
	         }
	}
*/

	// 'transmit' new output status to next module 'downstream'
	// getPin(PN_OUTPUT1)->TransmitStatusChange( SampleClock(), out_stat);// statt out_stat ralph
}


void Module::loadarray()
{ 
	 
      fopen_s(&stream, smidi_play_name , "r+b" );                    // FILEOPEN  ! r+b mode read+binary

      int filehandle = _fileno(stream);
      flang = _filelength(filehandle);
	  flang = flang / (sizeof(unsigned long) * 2);
      flang++;

	  if(admin)
	  {
      sprintf_s(text,400,"%s _fileno flang = %d \n","playkick1m", flang);
	  diag(text);
	  }

      //fclose(stream);// THAT WAS THE MIDIFILE 

      PLAY = false;
     // if(tak_time != NULL) delete [] tak_time;                // delete if used before
      if(tak_midi != NULL) delete [] tak_midi;
     
      //tak_time = new unsigned long [flang];         // resize ARRAY reset ARRAYINDEX
      tak_midi = new unsigned long [flang];

	  
      //if(stream) fclose (stream);

      //fopen_s(&stream, smidi_play_name , "r+b" );                    // FILEOPEN  ?rb
	  taki = 0; 
      while(! feof(stream))
      {
               fread(&pc,sizeof(unsigned long ),1,stream);        // TIME_pc_clock
      //tak_time[taki]= pc;
               fread(&md,sizeof(unsigned long ),1,stream);        // MIDI_msg
      tak_midi[taki]= md;
                    taki++;                                      // next two    
	  }
	  
      fclose(stream);// THAT WAS THE MIDIFILE 
          last_take = --taki;                                 // EndMarker
          taki = 0; pause_time = 0;
      if(admin)
	  {
      sprintf_s(text,400,"%s last_take= %d \n","playkick1M", last_take); diag(text);
	  }
}



